
BEGIN_PROVIDER [double precision, ao_ortho_lowdin_coef, (ao_num_align,ao_num)]
 BEGIN_DOC
! matrix of the coefficients of the mos generated by the 
! orthonormalization by the S^{-1/2} canonical transformation of the aos
! ao_ortho_lowdin_coef(i,j) = coefficient of the ith ao on the jth ao_ortho_lowdin orbital
 END_DOC
 implicit none
 integer :: i,j,k,l
 double precision :: tmp_matrix(ao_num_align,ao_num),accu
 do i = 1, ao_num
  do j = 1, ao_num
   tmp_matrix(i,j) = 0.d0
  enddo
 enddo
 do i = 1, ao_num
  tmp_matrix(i,i) = 1.d0
 enddo
 call ortho_lowdin(ao_overlap,ao_num_align,ao_num,tmp_matrix,ao_num_align,ao_num)
 do i = 1, ao_num
  do j = 1, ao_num
   ao_ortho_lowdin_coef(j,i) = tmp_matrix(i,j)
  enddo
 enddo
END_PROVIDER
BEGIN_PROVIDER [double precision, ao_ortho_lowdin_overlap, (ao_num_align,ao_num)]
 BEGIN_DOC
! overlap matrix of the ao_ortho_lowdin
! supposed to be the Identity
 END_DOC
 implicit none
 integer :: i,j,k,l
 double precision :: accu
 do i = 1, ao_num
  do j = 1, ao_num
   accu = 0.d0
   do k = 1, ao_num
    do l = 1, ao_num
     accu = accu + ao_ortho_lowdin_coef(i,k) * ao_ortho_lowdin_coef(j,l) * ao_overlap(k,l)
    enddo
   enddo
   ao_ortho_lowdin_overlap(i,j) = accu
  enddo
 enddo

END_PROVIDER
